/********************************************************************
	Rhapsody	: 6.1 
	Login		: Masood Khosroshahy
	Component	: mainComponent 
	Configuration 	: DefaultConfig
	Model Element	: Network
//!	Generated Date	: Tue, 28, Mar 2006  
	File Path	: mainComponent/DefaultConfig/Network.cpp
*********************************************************************/


//#[ ignore 
#define NAMESPACE_PREFIX 
//#]

#include "Network.h"

//## package Rip 


//#[ ignore 
#define Rip_Network_Network_SERIALIZE OM_NO_OP
//#]

//----------------------------------------------------------------------------
// Network.cpp                                                                  
//----------------------------------------------------------------------------
DECLARE_META_PACKAGE(Rip)
//## class Network 



Network::Network(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(Network, Network(), 0, Rip_Network_Network_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        {
            scheduler.setShouldDelete(false);
        }
        scheduler.setActiveContext(theActiveContext, false);
        {
            r1.setShouldDelete(false);
        }
        r1.setActiveContext(theActiveContext, false);
        {
            r2.setShouldDelete(false);
        }
        r2.setActiveContext(theActiveContext, false);
        {
            r3.setShouldDelete(false);
        }
        r3.setActiveContext(theActiveContext, false);
        {
            r4.setShouldDelete(false);
        }
        r4.setActiveContext(theActiveContext, false);
    }
    initRelations();
}

Network::~Network() {
    NOTIFY_DESTRUCTOR(~Network, true);
}

Router* Network::getR1() const {
    return (Router*) &r1;
}

Router* Network::getR2() const {
    return (Router*) &r2;
}

Router* Network::getR3() const {
    return (Router*) &r3;
}

Router* Network::getR4() const {
    return (Router*) &r4;
}

Scheduler* Network::getScheduler() const {
    return (Scheduler*) &scheduler;
}

void Network::destroy() {
    r1.destroy();
    r2.destroy();
    r3.destroy();
    r4.destroy();
    scheduler.destroy();
    OMReactive::destroy();
}

void Network::initRelations() {
    {
    	
    	r1.getPRIP4()->setItsDefaultRequiredInterface(r4.getPRIP1()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	r4.getPRIP1()->setItsDefaultRequiredInterface(r1.getPRIP4()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	r4.getPRIP2()->setItsDefaultRequiredInterface(r2.getPRIP4()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	r2.getPRIP4()->setItsDefaultRequiredInterface(r4.getPRIP2()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	r1.getPRIP2()->setItsDefaultRequiredInterface(r2.getPRIP1()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	r2.getPRIP1()->setItsDefaultRequiredInterface(r1.getPRIP2()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	r3.getPRIP2()->setItsDefaultRequiredInterface(r2.getPRIP3()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	r2.getPRIP3()->setItsDefaultRequiredInterface(r3.getPRIP2()->getItsDefaultProvidedInterface());
    	
    }
    {
    	
    	scheduler.getPRouter4()->setItsISchedulerRouter3(r4.getPScheduler()->getItsISchedulerRouter3());
    	
    }{
    	
    	r4.getPScheduler()->setItsIRouterScheduler1(scheduler.getPRouter4()->getItsIRouterScheduler1());
    	
    }
    {
    	
    	scheduler.getPRouter3()->setItsISchedulerRouter3(r3.getPScheduler()->getItsISchedulerRouter3());
    	
    }{
    	
    	r3.getPScheduler()->setItsIRouterScheduler1(scheduler.getPRouter3()->getItsIRouterScheduler1());
    	
    }
    {
    	
    	scheduler.getPRouter2()->setItsISchedulerRouter3(r2.getPScheduler()->getItsISchedulerRouter3());
    	
    }{
    	
    	r2.getPScheduler()->setItsIRouterScheduler1(scheduler.getPRouter2()->getItsIRouterScheduler1());
    	
    }
    {
    	
    	scheduler.getPRouter1()->setItsISchedulerRouter3(r1.getPScheduler()->getItsISchedulerRouter3());
    	
    }{
    	
    	r1.getPScheduler()->setItsIRouterScheduler1(scheduler.getPRouter1()->getItsIRouterScheduler1());
    	
    }
    {
    	
    	scheduler.getPTimerOut()->setItsDefaultRequiredInterface(scheduler.getPTimerIn()->getItsDefaultProvidedInterface());
    	
    }{
    	
    	scheduler.getPTimerIn()->setItsDefaultRequiredInterface(scheduler.getPTimerOut()->getItsDefaultProvidedInterface());
    	
    }
}

bool Network::startBehavior() {
    bool done = false;
    r1.startBehavior();
    r2.startBehavior();
    r3.startBehavior();
    r4.startBehavior();
    scheduler.startBehavior();
    done = OMReactive::startBehavior();
    return done;
}



#ifdef _OMINSTRUMENT


void OMAnimatedNetwork::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("scheduler", true, true);
    aomsRelations->ADD_ITEM(&myReal->scheduler);
    aomsRelations->addRelation("r1", true, true);
    aomsRelations->ADD_ITEM(&myReal->r1);
    aomsRelations->addRelation("r2", true, true);
    aomsRelations->ADD_ITEM(&myReal->r2);
    aomsRelations->addRelation("r3", true, true);
    aomsRelations->ADD_ITEM(&myReal->r3);
    aomsRelations->addRelation("r4", true, true);
    aomsRelations->ADD_ITEM(&myReal->r4);
}

IMPLEMENT_REACTIVE_META_SIMPLE(Network, Rip, false, OMAnimatedNetwork)
#endif // _OMINSTRUMENT


/*********************************************************************
	File Path	: mainComponent/DefaultConfig/Network.cpp
*********************************************************************/

